#!/bin/bash

# This is a tempfile(1) replacement. Only supported argument is "-s" yet
# (for temp filename suffix). Config will use this script on a system where
# tempfile isn't supported.

if test "$1" = "-s"
then
	suffix=$2
else
	suffix=""
fi

name_=`mktemp /tmp/cfgtmpXXXXXX`
if test -z "$suffix"
then
	name=${name_}
else
	name="${name_}${suffix}"
	mv $name_ $name || exit 1
fi

echo $name
