#include <stdio.h>
#include <string.h>
#include "gpmi.h"

int main() {
	gpmi_module *mod_example;
	int n;

	gpmi_path_append(GPMI_PATH_MODULES, GPMI_ROOT "/modules");
#ifdef WINDLL
	gpmi_path_append(GPMI_PATH_PACKAGES, GPMI_ROOT "/gpmi_pkg");
#else
	gpmi_path_append(GPMI_PATH_PACKAGES, GPMI_ROOT "/packages");
#endif
	gpmi_init();

	mod_example = gpmi_mod_load("example", "Init-params");

	if (mod_example == NULL) {
		printf("Couldn't open example module, quiting\n");
		gpmi_uninit();
		return 1;
	}

	gpmi_call_Debug(mod_example, "Debug works.");

	for(n = 0; n < 4; n++)
		gpmi_call_RunTick(mod_example, n);

	gpmi_call_RunData(mod_example, (void *)0x1234);

	gpmi_mod_unload(mod_example);

	gpmi_uninit();

	printf("Example finished.\n");

	return 0;
}
