/**
 * @file debug.h
 *  \brief Helps out to show debug-information to the end-user.
 *
 *  Use gpmi_debug(level, <your text here>) to say something to the user.
 *  Level 0 means _VERY_ important, where level 9 is far less important.
 */
#ifndef GPMI_DEBUG_H
#define GPMI_DEBUG_H

#include <gpmi/global.h>

void (*gpmi_debug_proc)(int level, char *s);

#define gpmi_debug(level, x...)	{          \
		char gpmi_debug_buff[1024];            \
		snprintf(gpmi_debug_buff, 1024, x);      \
		if (gpmi_debug_proc != NULL) \
			gpmi_debug_proc(level, gpmi_debug_buff); \
		else \
			printf("gpmi debug: %d %s\n", level, gpmi_debug_buff); \
	}
//!< Call this macro to show debug-information to the user

#endif /* GPMI_DEBUG_H */
