#ifndef GPMI_PATHS_H
#define GPMI_PATHS_H

typedef enum gpmi_paths_e {
	GPMI_PATH_MODULES,
	GPMI_PATH_PACKAGES,
	GPMI_PATH_SCRIPTS,
} gpmi_paths_t;

/* Wrappers to manipulate gpmi wrappers */
void gpmi_path_append(gpmi_paths_t gpmi_path, const char *path);
void gpmi_path_insert(gpmi_paths_t gpmi_path, const char *path);
int  gpmi_path_find(gpmi_paths_t gpmi_path, const char *path);
int  gpmi_path_delete(gpmi_paths_t gpmi_path, const char *path);


/* Direct string manipulation functions */
void gpmi_path_append_(char **gpmi_path, const char *path);
void gpmi_path_insert_(char **gpmi_path, const char *path);
int  gpmi_path_find_(const char **gpmi_path, const char *path);
int  gpmi_path_delete_(char **gpmi_path, const char *path);

#endif /* GPMI_PATHS_H */
