#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <assert.h>
#include "cli_core.h"

#define delay 1
/* Timeout (unit is delay's value) */
#define read_timeout 10 

#define GPMI_FIN "###GPMI_FIN###"
#define GPMI_FIN_LEN 14

#define TEST1 "Here is some data,enjoy"
#define TEST2 "wohoo, time's up!"


int bgproc_read_from_pipe_block(int fd, char *s, int length, int timeout)
{
	int len;

	#warning: unfinished: this will need to use the filter package
	while(timeout > 0) {
		len = bgproc_read_from_pipe(fd, s, length);
		if (strncmp(s, GPMI_FIN, GPMI_FIN_LEN) == 0)
			return len;
		#ifdef WIN32
			Sleep(delay);
		#else
			usleep(delay);
		#endif
		timeout--;
	}
	return -1;
}


int main() {
	char *before, *after, *dir;
	int res;
	cli_t *c;

	int len;
	char s[1024];

	before = NULL;
	after  = NULL;
	dir    = NULL;

	res = cli_read_confs("none", &dir, &before, &after);
	if (res != -2)
		printf("Test failed: expected -2 but got %d (%d)\n", res, __LINE__);

	before = NULL;
	after  = NULL;
	dir    = NULL;

	res = cli_read_confs("bash", &dir, &before, &after);
	if (res != 0)
		printf("Test failed: expected 0 but got %d (%d)\n", res, __LINE__);

	assert(dir != NULL);
	assert(before != NULL);
	assert(after != NULL);

	c = cli_fork(dir, before, "test.sh", after);
	printf("%d %d\n", c->fds_a[0], c->fds_a[1]);

	/* Init */
	printf("Reading...\n");

	len = bgproc_read_from_pipe_block(c->fds_b[0], s, sizeof(s), read_timeout); s[len > 0 ? len-1 : 0] = '\0';
	printf("R %d: '%s' == 'MAIN'\n", len, s);

	len = bgproc_read_from_pipe_block(c->fds_b[0], s, sizeof(s), read_timeout); s[len >= 0 ? len : 0] = '\0';
	printf("R %d: '%s' == ''\n", len,s);

	/* RunData */
	strcpy(s, "RunData " TEST1 "\n");
	bgproc_write_to_pipe(c->fds_a[1], s, strlen(s));
	len = bgproc_read_from_pipe_block(c->fds_b[0], s, sizeof(s), read_timeout); s[len > 0 ? len-1 : 0] = '\0';
	printf("R %d: '%s' == 'Data: " TEST1 "'\n", len, s);


	/* RunTick */
	strcpy(s, "RunTick " TEST2 "\n");
	bgproc_write_to_pipe(c->fds_a[1], s, strlen(s));
	len = bgproc_read_from_pipe_block(c->fds_b[0], s, sizeof(s), read_timeout); s[len > 0 ? len-1 : 0] = '\0';
	printf("R %d: '%s' == 'Tick: " TEST2 "'\n", len, s);


	free(before);
	free(after);
	free(dir);

	return 0;
}
