#ifndef SCRIPT_MODULE_GHLI_H
#define SCRIPT_MODULE_GHLI_H

#include <ghli.h>
#include "packages/gpmi_scripts.h"

typedef struct GHLI_ClientData {
	ghli_t *h;
	char *script_name;
	const gpmi_package *loading;
} GHLI_ClientData;

int  GHLI_Initialize(void **client_data);
void GHLI_Destroy(void **client_data);
void GHLI_RegisterCommand(void *client_data, const char *name);
int  GHLI_LoadScript(void *client_data, const char *filename);
char *GHLI_GetExtension();
int  GHLI_Rehash(void *client_data);
void GHLI_RunFunction(void *client_data, const char *function, int argc, const char **argv);
void GHLI_SetPkg(void *client_data, const gpmi_package *package);

// GHLI.c
void GHLI_ReportGHLIError(GHLI_ClientData *GHLI_MyData, int error);

#endif /* SCRIPT_MODULE_GHLI_H */
