#include "php.h"

#include <stdio.h>
#include <string.h>
#include <gpmi/modules.h>

const GPMI_Script_Info PHP_Proc_Info = {
	&PHP_Initialize,
	&PHP_Destroy,
	&PHP_GetExtension,
	&PHP_RegisterCommand,
	&PHP_LoadScript,
	NULL,
	&PHP_CallFunction,
	NULL,
	1, // PHP doesn't like uppercase function names, make sure they are all lowercase..
};

void gpmi_mod(Uninitialize)(gpmi_module *module)
{
	GPMI_Script_Destroy(module);
}

int gpmi_mod(Initialize)(gpmi_module *module, const char *params)
{
	int res;

	res = GPMI_Script_Load(&PHP_Proc_Info, module, params);

	if (res < -3)
		gpmi_mod(Uninitialize)(module);

	return res;
}

void gpmi_mod(RunTick)(gpmi_module *module, int frame_counter)
{
	GPMI_Script_RunTick(module, frame_counter);
}

void gpmi_mod(RunData)(gpmi_module *module, void *data)
{
	GPMI_Script_RunData(module, data);
}

int gpmi_mod(Debug)(gpmi_module *module, const char *command)
{

	return 0;
}
