#include "ruby.h"

#include <stdio.h>
#include <string.h>
#include <gpmi/modules.h>

const GPMI_Script_Info Ruby_Proc_Info = {
	&Ruby_Initialize,
	&Ruby_Destroy,
	&Ruby_GetExtension,
	&Ruby_RegisterCommand,
	&Ruby_LoadScript,
	NULL,
	&Ruby_CallFunction,
	NULL,
	0,
};

void gpmi_mod(Uninitialize)(gpmi_module *module)
{
	GPMI_Script_Destroy(module);
}

int gpmi_mod(Initialize)(gpmi_module *module, const char *params)
{
	int res;

	res = GPMI_Script_Load(&Ruby_Proc_Info, module, params);

	if (res != 0)
		gpmi_mod(Uninitialize)(module);

	return res;
}

void gpmi_mod(RunTick)(gpmi_module *module, int frame_counter)
{
	GPMI_Script_RunTick(module, frame_counter);
}

void gpmi_mod(RunData)(gpmi_module *module, void *data)
{
	GPMI_Script_RunData(module, data);
}

int gpmi_mod(Debug)(gpmi_module *module, const char *command)
{

	return 0;
}
