/* STUTTER GPMI module */

#include "stutter.h"

static const GPMI_Script_Info Stutter_Proc_Info = {
	&Stutter_Initialize,
	&Stutter_Destroy,
	&Stutter_GetExtension,
	&Stutter_RegisterCommand,
	&Stutter_LoadScript,
	&Stutter_Rehash,
	&Stutter_RunFunction,
	NULL,
	0,
};

void gpmi_mod_RunTick(gpmi_module *module, int frame_counter)
{
	GPMI_Script_RunTick(module, frame_counter);
}

void gpmi_mod_RunData(gpmi_module *module, void *data)
{
	GPMI_Script_RunData(module, data);
}

/**
 * Run direct Stutter command from the console. For debugging.
 * At this time it runs in the interpreter of the current AI that is
 * fine with the single AI approach. Later we will need to add commands
 * to switch between AIs.
*/
int gpmi_mod_Debug(gpmi_module *module, const char *parameters)
{
//	Stutter_ClientData *Stutter_MyData = module->mod_data;

	return 0;
}

/**
 * Necessarry routines to init/uninit the module
 */
int gpmi_mod_Initialize(gpmi_module *module, const char *params)
{
	return GPMI_Script_Load(&Stutter_Proc_Info, module, params);
}

void gpmi_mod_Uninitialize(gpmi_module *module)
{
	GPMI_Script_Destroy(module);
}
