#ifndef os_dep_h_included
#define os_dep_h_included


#ifdef WIN32
	#include <windows.h>
	typedef HANDLE pipe_t;

	// global var to kill child process on exit
	HANDLE _hProcess;
#else
	typedef int pipe_t;
#endif

typedef enum PipeType {
	BGPROC_PIPE_READ  = 0,
	BGPROC_PIPE_WRITE = 1,
} PipeType;

int bgproc_create_pipe(pipe_t p[2], PipeType t);
int bgproc_create_child(char* commandline, pipe_t pa[2], pipe_t pb[2]);
int bgproc_write_to_pipe(pipe_t p, char *buf, int buf_len);
int bgproc_read_from_pipe(pipe_t p, char *buf, int buf_len);

#endif /* os_dep_h_included */
