#ifndef filter_h_included
#define filter_h_included

#include <gpmi.h>

typedef struct filter_t {
	char *data;
	int la;												//allocated length
	int l;												//data length
	char *sep;										//separators
	int next;											//next data
	int last;											//last checked byte
	int skip;											//alloc extra bytes every time when data grows
	int flags;
	int step;											//return n bytes at once IF NO SEP DEFINED
} filter_t;

#define flt_oversep	1

char *flt_ws;

void flt_change_sep(filter_t *f, char *newsep);
void flt_step(filter_t *f, int step);
int flt_fill(filter_t *f, char *dt, int len, char **res);
filter_t *flt_init(char *sep, int skip, int flags);
int flt_peek_skip(filter_t *f, char **res);
void flt_close(filter_t *f);

#endif /* filter_h_included */
