#ifndef GPMI_SCRIPT_SCRIPTS_H
#define GPMI_SCRIPT_SCRIPTS_H

#include "gpmi/hash/hash.h"
#include "packages/timer.h"
#include "module_events.h"

char *(*gpmi_scripts_asm_scriptname)(const GPMI_Script_Info *info, const char *file_name);


typedef struct GPMI_Script_ClientData {
	const GPMI_Script_Info *info;
	
	char *current_script_dir;

	hash_t *cmd_hash;
	module_events *events;

	int last_frame;
	timer_list *timers;
	gpmi_package *timer_pkg;

	void *client_data;

	gpmi_package *package;
} GPMI_Script_ClientData;


typedef struct GPMI_Script_EventData {
	GPMI_Script_ClientData *client_data;
	int argc;
	char **argv;
} GPMI_Script_EventData;

typedef struct GPMI_Script_TimerData {
	char *script;
	char *user_data;
	int TTL;
	int freq;
} GPMI_Script_TimerData;

void GPMI_Script_RegisterCommand(void *handle, char *name, void *proc_wrapper, void *proc_lowlevel, gpmi_package *pkg);
void GPMI_Script_Event_Callback(void *handle, void *data);
void GPMI_Script_Timer_Callback(timer_cmds cmd, void *data, timer *timer);
void GPMI_Script_FreeModuleEventData(void *data);
int  GPMI_Script_CompareModuleEventData(void *data1, void *data2);

#endif /* GPMI_SCRIPT_SCRIPTS_H */
