#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "keywords.h"

const gpmi_keyword_static_int gpmi_kw_ska[] = {
	{"integer",		gpmi_keyword_type_integer},
	{"string",		gpmi_keyword_type_string},
	{"pointer",		gpmi_keyword_type_pointer},
	{NULL, 0}
} ;

void *gpmi_kw_create(const char *table_name, int value_type)
{
	return gpmi_keyword_create(table_name, value_type);
}

int gpmi_kw_add_int(void *keyword_table, const char *name, int data)
{
	return gpmi_keyword_add(keyword_table, name, data);
}

int gpmi_kw_add_int_auto(void *keyword_table, const char *name)
{
	return gpmi_keyword_add_auto(keyword_table, name);
}

int gpmi_kw_add_string(void *keyword_table, const char *name, char *data)
{
	return gpmi_keyword_add(keyword_table, name, data);
}

int gpmi_kw_add_ptr(void *keyword_table, const char *name, void *data)
{
	return gpmi_keyword_add(keyword_table, name, data);
}

int gpmi_kw_find_int(void *keyword_table, const char *name)
{
	return gpmi_keyword_find_int_numeric(keyword_table, name);
}

char *gpmi_kw_find_string(void *keyword_table, const char *name)
{
	return strdup(gpmi_keyword_find_string(keyword_table, name));
}

const void *gpmi_kw_find_ptr(void *keyword_table,  const char *name)
{
	return gpmi_keyword_find_ptr(keyword_table, name);
}

int gpmi_kw_find_multi(void *keyword_table, const char *key)
{
	int res;
	
	gpmi_keyword_find_multi(keyword_table, key, &res);

	return res;
}

