#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "gpmi.h"
#include "common.h"

void init()
{
	gpmi_init();

	gpmi_path_insert(GPMI_PATH_MODULES,  GPMI_ROOT "/modules");
	gpmi_path_insert(GPMI_PATH_PACKAGES, GPMI_ROOT "/packages");
}


/* Register all the known routines, ignore unknown ones */
void reg_cmd(void *handle, char *name, void *proc_wrap, void *proc_lowlevel, gpmi_package *pkg)
{
	pkg_proc_t *t;

	
	for(t = pkg_procs; t->proc_text != NULL; t++) {
		if (strcmp(name, t->name) == 0) {
			*(t->proc_text) = proc_wrap;
			*(t->proc_bin)  = gpmi_pkg_resolve(pkg, t->name);
		}
	}
}

/* Check all the known routines, fail if at least one is missing */
void chk_cmd()
{
	pkg_proc_t *t;
	int ret = 0;
	
	for(t = pkg_procs; t->proc_text != NULL; t++) {
		if ((*(t->proc_text)) == NULL) {
			ret++;
			fprintf(stderr, "Package didn't register routine %s.\n", t->name);
		}
	}
}

