#include <stdlib.h>

typedef struct param_t param_t;
typedef struct func_t func_t;
typedef struct event_t event_t;
typedef struct keyword_t keyword_t;
typedef struct faketype_t faketype_t;
typedef struct param_stack_t param_stack_t;
typedef struct enum_element_t enum_element_t;
typedef struct enum_t enum_t;

struct enum_element_t {
	char *name;
	enum_element_t *next;
};

struct enum_t {
	char *name;
	enum_element_t *elements;
	enum_t *next;
};

struct param_t {
	char *name;
	char *type;
	param_t *next;
} ;

struct param_stack_t {
	param_t **params;
	param_stack_t *next;
} ;

struct func_t {
	char *name;
	char *type;
	param_t *params;
	func_t *next;
} ;

struct event_t {
	char *name;
	param_t *params;
	event_t *next;
};

struct keyword_t {
	char *name;
	param_t *params;
	int type;
	keyword_t *next;
} ;

struct faketype_t {
	char *name;
	char *type;
	faketype_t *next;
} ;

enum keyword_types {
	kw_type_export = 1,
	kw_type_local  = 2,
} ;

func_t *functions;
event_t *events;
keyword_t *keywords;
param_stack_t *param_stack;
enum_t *enums;

int in_struct;
int verbose;
int enum_nowrap;

int check_kw(char *name);
void func_add(char *type, char *name);
void func_add_direct(char *name);
void param_add(char *type, char *name);
void event_add(char *name);
void keyword_add(char *name, int type, char *type_name);
char *chr_insert(char *string, char c);
void faketype_add(char *name, char *type);
void curr_params_push();
void curr_params_pop();

void enum_create(char *enum_name);
void enum_add_element(char *element_name);
void enum_close();


param_t **curr_params;

#define verbprintf(level, x...)			if (verbose >= level) printf(x)
